# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
# Copyright (C) 2023 Aspeed, Inc.
%YAML 1.2
---
$id: http://devicetree.org/schemas/hwmon/aspeed,g6-pwm-tach.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: ASPEED G6 PWM and Fan Tach controller

maintainers:
  - Billy Tsai <billy_tsai@aspeedtech.com>

description: |
  The ASPEED PWM controller can support up to 16 PWM outputs.
  The ASPEED Fan Tacho controller can support up to 16 fan tach input.
  They are independent hardware blocks, which are different from the
  previous version of the ASPEED chip.

properties:
  compatible:
    oneOf:
      - items:
          - const: aspeed,ast2700-pwm-tach
          - const: aspeed,ast2600-pwm-tach
      - const: aspeed,ast2600-pwm-tach

  reg:
    maxItems: 1

  clocks:
    maxItems: 1

  resets:
    maxItems: 1

  "#pwm-cells":
    const: 3

patternProperties:
  "^fan-[0-9]+$":
    $ref: fan-common.yaml#
    unevaluatedProperties: false
    required:
      - tach-ch

required:
  - reg
  - clocks
  - resets
  - "#pwm-cells"
  - compatible

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/aspeed-clock.h>
    pwm_tach: pwm-tach-controller@1e610000 {
      compatible = "aspeed,ast2600-pwm-tach";
      reg = <0x1e610000 0x100>;
      clocks = <&syscon ASPEED_CLK_AHB>;
      resets = <&syscon ASPEED_RESET_PWM>;
      #pwm-cells = <3>;

      fan-0 {
        tach-ch = /bits/ 8 <0x0>;
        pwms = <&pwm_tach 0 40000 0>;
      };

      fan-1 {
        tach-ch = /bits/ 8 <0x1 0x2>;
        pwms = <&pwm_tach 1 40000 0>;
      };
    };
